#pragma once
//using namespace std;
//#include <utility>

#define void_proc_c typedef void (__cdecl *zProc)
#define long_proc_c typedef long (__cdecl *zProc)
#define short_proc typedef short (__stdcall *zProc)
#define long_proc typedef long (__stdcall *zProc)
#define char_proc typedef char* (__stdcall *zProc)
#define wchar_proc typedef WCHAR* (__stdcall *zProc)
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16))
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define UBOUND(T) (T.size())

static long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

//extern "C" void* __cdecl memmove(void* dst, void const* src, size_t n) {
//    void* ret = dst;
//
//    if (dst != nullptr && src != nullptr) {
//        if (dst <= src || (char*) dst >= ((char*) src + n)) {
//            // Non-overlapping buffers; copy from lower addresses to higher addresses
//            while (n--) {
//                *(char*) dst = *(char*) src;
//                dst = (char*) dst + 1;
//                src = (char*) src + 1;
//            }
//        } else {
//            // Overlapping buffers; copy from higher addresses to lower addresses
//            dst = (char*) dst + n - 1;
//            src = (char*) src + n - 1;
//            while (n--) {
//                *(char*) dst = *(char*) src;
//                dst = (char*) dst - 1;
//                src = (char*) src - 1;
//            }
//        }
//    } else {
//        ret = nullptr;
//    }
//    
//    return ret;
//}

static long rWidth(IN RECT &r){
    return r.right - r.left;
}

static long rHeight(IN RECT &r) {
    return r.bottom - r.top;
}

static void ClearMemory(IN void* mem, IN long nSize) {
#ifdef _WIN64
    __stosb((PBYTE) mem, (BYTE) 0, (SIZE_T) nSize);
#elif defined(_WIN32)
    memset(mem, 0, nSize);
#endif
}

static long my_wcsicmp(const WCHAR* s1, const WCHAR* s2) {
    while (*s1 && *s2) {
        wchar_t c1 = towlower(*s1);
        wchar_t c2 = towlower(*s2);

        if (c1 != c2) return c1 - c2;
        s1++;
        s2++;
    }
    return towlower(*s1) - towlower(*s2);
}

static WCHAR* EXEpath() {
    static WCHAR zpath[MAX_PATH];
    static long done;
    if (done == 0) {
        ClearMemory(zpath, sizeof(zpath));
        if (GetModuleFileName(0, zpath, strSize(zpath))) {
            long nLen = lstrlen(zpath);
            long nPos = nLen;
            for (long K = 1; K <= nLen; K++) {
                if (_wcsicmp(&zpath[nPos - K], L"\\") != 0) { 
                    zpath[nPos - K] = NULL;
                } else {
                    break;
                }
            }
        }
        done = -1;
    }
    return zpath;
}

static WCHAR* Path_Combine(OUT WCHAR* zResource, IN WCHAR* path, IN const WCHAR* combine) {
    // This version try to protect from buffer overflow
    long nLenPath = lstrlen(path), nLenCombine = lstrlen(combine);
    ClearMemory(zResource, MAX_PATH * sizeof(WCHAR));
    if (nLenPath < MAX_PATH) {
        memmove(zResource, path, nLenPath * sizeof(WCHAR));
        if (nLenPath + nLenCombine < MAX_PATH) {
            memmove(&zResource[nLenPath], &combine[0], nLenCombine * sizeof(WCHAR));
        }
    }
    return zResource;
}

static WCHAR* EXEresource() {
    static WCHAR zpath[MAX_PATH];
    static long done;
    if (done == 0) {
        ClearMemory(zpath, sizeof(zpath));
        Path_Combine(zpath, EXEpath(), L"Resource\\");
        done = -1;
    }
    return zpath;
}

static WCHAR* Resource(IN const WCHAR* sFile) {
    static WCHAR zpath[MAX_PATH];
    ClearMemory(zpath, sizeof(zpath));
    Path_Combine(zpath, EXEresource(), sFile);
    return zpath;
}

static BOOL FileExist(IN WCHAR* szFileSpec) {
    DWORD dwAttr = GetFileAttributesW(szFileSpec);
    return ((dwAttr != INVALID_FILE_ATTRIBUTES) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
}

DWORD FileSize(IN WCHAR* szFileSpec) {
    DWORD nRet = 0;
    if (lstrlen(szFileSpec)) {
        HANDLE hFind;
        WIN32_FIND_DATA fd; ClearMemory(&fd, sizeof(fd));
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

static WCHAR* wcscopy(IN WCHAR* dst, IN const WCHAR* src, IN long size = MAX_PATH) {
    if (!dst || !src || size <= 0) return NULL; // Handle invalid parameters

    long nLen = min(lstrlen(src), size - 1); if (nLen < 0) nLen = 0; // Handle negative length case

    memmove(dst, src, nLen * sizeof(WCHAR));
    dst[nLen] = L'\0'; // Ensure null-termination
    return dst;
}

// This function appends the source string (srce) to the destination string (dest).
// Assumes dest has enough space to hold the result.
// Returns 0 on success, -1 on error (e.g., if either pointer is NULL).
static long Add_Str(OUT WCHAR* dest, IN const WCHAR* srce) {
    if (dest == NULL || srce == NULL) return -1; // Error: NULL pointer

    // Find the end of the destination string
    WCHAR* dest_end = dest;
    while (*dest_end != L'\0') { dest_end++; }

    // Append the source string to the destination string
    while (*srce != L'\0') {
        *dest_end = *srce;
        dest_end++;
        srce++;
    }

    // Null-terminate the result
    *dest_end = L'\0';

    return 0; // Success
}

WCHAR* tcsstr(WCHAR* String, const WCHAR* Pattern) {
    int mi = -1;
    while(Pattern[++mi]) {
        if(String[mi] == 0) return 0;
        if(String[mi] != Pattern[mi]) {
            String++;
            mi = -1;
        }
    }
    return String;
}

void List_DeleteAll(IN HWND hList) {
    if (hList) { SendMessage(hList, LB_RESETCONTENT, 0, 0); }
}

static LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (lstrlen(zTmp)) nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp);
    return nIndex;
}

static WCHAR* List_GetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    ClearMemory(szData, sizeof(szData));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

static long List_GetCursel(IN HWND hList) {
    long nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
    if (nIndex > -1) ++nIndex; // Because ListBox is zero based
    return nIndex;
}

static long List_Count(IN HWND hList) {
    return (long) SendMessage(hList, LB_GETCOUNT, 0, 0);
}

static long List_FindString(IN HWND hList, IN WCHAR* zTmp) {
    long nIndex = (long) SendMessage(hList, LB_FINDSTRING, -1, (LPARAM) zTmp);
    if (nIndex > -1) ++nIndex;
    return nIndex;
}

static void List_SelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex > 0) {
        --nIndex; // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0);
    }
}

static WCHAR* STRL(long num) {
    static WCHAR wstr[33];  // Static buffer to hold the result (32 characters + null terminator)
    int len = 32;           // Start from the end of the buffer
    int negative = 0;

    wstr[len] = L'\0';      // Null-terminate the string
    len--;

    if (num == 0) {
        wstr[len] = L'0'; len--;
    } else {
        if (num < 0) {
            negative = 1; num = -num;
        }

        while (num > 0) {
            wstr[len] = (WCHAR)(L'0' + (num % 10));
            num /= 10; len--;
        }

        if (negative) {
            wstr[len] = L'-'; len--;
        }
    }

    return &wstr[len + 1];  // Return the pointer to the first character of the result
}

// Function to convert a float to a WCHAR string
static WCHAR* STRF(float num, int precision) {
    static WCHAR wstr[33];  // Static buffer to hold the result (32 characters + null terminator)
    int len = 0;
    int negative = 0;
    long whole_part;
    float fractional_part;

    if (num < 0) { negative = 1; num = -num; }

    // Calculate the rounding factor as 0.5 / (10^precision)
    float rounding_factor = 0.5f;
    for (int i = 0; i < precision; i++) {
        rounding_factor /= 10.0f;
    }
    num += rounding_factor;

    whole_part = (long)num;              // Get the integer part
    fractional_part = num - whole_part;  // Get the fractional part

    // Convert integer part
    do {
        wstr[len++] = (WCHAR)(L'0' + (whole_part % 10));
        whole_part /= 10;
    } while (whole_part > 0);

    if (negative) wstr[len++] = L'-';

    // Reverse the integer part
    for (int i = 0; i < len / 2; i++) {
        WCHAR temp = wstr[i];
        wstr[i] = wstr[len - i - 1];
        wstr[len - i - 1] = temp;
    }

    // Add the decimal point
    if (precision > 0) wstr[len++] = L'.';

    // Convert fractional part
    for (int i = 0; i < precision; i++) {
        fractional_part *= 10;
        int digit = (int)fractional_part;
        wstr[len++] = (WCHAR)(L'0' + digit);
        fractional_part -= digit;
    }

    wstr[len] = L'\0';  // Null-terminate the string

    return wstr;
}

static void wsplitpath(const WCHAR* path, WCHAR* drive, WCHAR* dir, WCHAR* fname, WCHAR* ext) {
    const WCHAR* end; /* End of the processed string */
    const WCHAR* p;   /* Search pointer */
    const WCHAR* s;   /* Copy pointer */

    // Extract drive name
    if (path[0] && path[1] == L':') {
        if (drive) {
            *drive++ = *path++;
            *drive++ = *path++;
            *drive = L'\0'; // Null-terminate the drive string
        }
    } else if (drive) {
        *drive = L'\0'; // No drive specified
    }

    end = path + lstrlen(path); // End of the path string

    // Search for the beginning of the file extension
    for (p = end; p > path && *--p != L'\\' && *p != L'/'; ) {
        if (*p == L'.') {
            end = p;
            break;
        }
    }

    // Extract the file extension
    if (ext) {
        for (s = end; (*ext = *s++); ) {
            ext++;
        }
        *ext = L'\0'; // Null-terminate the extension string
    }

    // Search for the end of the directory name
    for (p = end; p > path; ) {
        if (*--p == L'\\' || *p == L'/') {
            p++; // Move past the last slash or backslash
            break;
        }
    }

    // Extract the filename
    if (fname) {
        for (s = p; s < end; ) {
            *fname++ = *s++;
        }
        *fname = L'\0'; // Null-terminate the filename string
    }

    // Extract the directory (e.g., "C:\\" or "")
    if (dir) {
        for (s = path; s < p; ) {
            *dir++ = *s++;
        }
        *dir = L'\0'; // Null-terminate the directory string
    }
}

// Function to get file extension
static WCHAR* GetFileExtension(const WCHAR* path) {
    static WCHAR ext[32];
    ClearMemory(ext, sizeof(ext));

    const WCHAR* end = path + lstrlenW(path);  // End of the path string
    const WCHAR* p = end;                      // Search pointer
    const WCHAR* s = NULL;                     // Copy pointer

    // Search for the beginning of the file extension
    while (p > path && *--p != L'\\' && *p != L'/') {
        if (*p == L'.') { s = p; break; }
    }

    // Extract file extension
    if (s) {
        WCHAR* dest = ext;
        *dest++ = L'.'; // Start with a dot
        s++; // Skip the initial dot
        while ((*dest = *s++) != 0) {
            *dest = towlower(*dest);  // Convert to lowercase
            dest++;
        }
        *dest++ = L'.'; // Add the ending dot
        *dest = L'\0';  // Null-terminate the string
    }

    return ext;
}

const int MEDIA_IMAGE        = 1;
const int MEDIA_VIDEO        = 2;
const int MEDIA_BASS_MUSIC   = 3;
const int MEDIA_BASS_STREAM  = 4;

static long MediaCheckExtension(IN WCHAR* zFileName) {
    long nRet = 0;
    if (zFileName) {
        //WCHAR drive[_MAX_DRIVE]; ClearMemory(drive, sizeof(drive));
        //WCHAR dir[_MAX_DIR]; ClearMemory(dir, sizeof(dir));
        //WCHAR fname[_MAX_FNAME]; ClearMemory(fname, sizeof(fname));
        //WCHAR ext[_MAX_EXT]; ClearMemory(ext, sizeof(ext));
        WCHAR ext[32]; ClearMemory(ext, sizeof(ext));
        //wsplitpath(zFileName, drive, dir, fname, ext);
        wcscopy(ext, GetFileExtension(zFileName), sizeof(ext));
        if (lstrlen(ext)) {
            //Add_Str(ext, L".");
            //CharLower(ext);
            if (tcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) return MEDIA_IMAGE;
            if (tcsstr(L".avi.wmv.mpeg.mpg.mov.qt.mkv.mp4.flv.webm.", ext)) return MEDIA_VIDEO;
            if (tcsstr(L".mo3.it.xm.s3m.mtm.mod.umx.", ext)) return MEDIA_BASS_MUSIC;
            if (tcsstr(L".mp3.wav.ogg.aif.", ext)) nRet = MEDIA_BASS_STREAM;
        }
    }
    return nRet;
}

static void PutFocusOn(IN HWND nObjectHandle, IN LPARAM lParam = 0) {
    PostMessage(nObjectHandle, WM_LBUTTONDOWN, 0, lParam);
    PostMessage(nObjectHandle, WM_LBUTTONUP, 0, lParam);
}

static void WindowRedraw(IN HWND hWnd) {
    RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
}

static WCHAR* cswconv(IN char* src) { // C string to WCHAR
    static WCHAR dst[4097]; // zero terminated
    mbstowcs(dst, src, 4096);
    return dst;
}

static CHAR* wcsconv(IN wchar_t* src) { // WCHAR to C string
    static CHAR dst[4097]; // zero terminated
    wcstombs(dst, src, 4096);
    return dst;
}