#pragma once
const int IDC_GLCTRL       =-100;
//#define IDC_STATIC     -101
//#define IDC_LABEL      -102
//#define IDC_ZOOM       -103
//#define IDC_CLOCK      -104
//#define IDC_RESET      -105
//#define IDC_STATIC_IMG -106
const int IDC_TIMER        =-107;

constexpr auto OPAQUEIMAGE = 0xFFFFFFFF;
constexpr auto HIGHLIGHT   = 0xFF037BFA;

const int IDI_ICON1        = 101;
const int IDC_PLUGINLIST   = 108;

const int ID_BACKGROUND    = 501;
const int ID_FLARE         = 502;
const int ID_COPYRIGHT     = 503;
const int ID_PIE_CROWN     = 504;
const int ID_PIE_OUT       = 505;
const int ID_PIE_IN        = 506;
const int ID_PIE_TEXT      = 507;

const int ID_SEEKTRACK     = 510;
const int ID_SEEKTHUMB     = 511;

const int ID_PUSH_BUTTON   = 600;
const int ID_BTN_PAUSE     = ID_PUSH_BUTTON + 4;
const int ID_BTN_PLAY      = ID_PUSH_BUTTON + 5;

const int ID_WIDGET        = 1000;
const int ID_SLIDER_HORZ   = ID_WIDGET + 500;
const int ID_THUMB_HORZ    = ID_WIDGET + 510;
const int ID_PROGRESS_HORZ = ID_WIDGET + 520;

// Must be last
const int ID_ARROW         = 2000;
const int ID_LARROW        = ID_ARROW + 1;
const int ID_RARROW        = ID_ARROW + 2;;

const int ClientW = 960;
const int ClientH = 540;

typedef struct {
    WCHAR lastplugin[MAX_PATH];
    long  audiolevel;
} SETBIN;

typedef struct {
    HWND        hMain;
    HWND        hGL;
    HWND        hGDImage;
    HWND        hPluginlist;
    long        MinTrackSizeW;
    long        MinTrackSizeH;

    WNDPROC     hGLproc;
    HDC         hDC;
    HGLRC       hRC;
    long        pluginloaded;
    HMODULE     hLib;

    SETBIN      bin;         // To store the preferences
    WCHAR       title[32];
    WCHAR       author[64];
    WCHAR       plugintitle[MAX_PATH * 2];
    WCHAR       wasLabel[64];
    WCHAR       version[16];

} PROP;

PROP gP;

struct GD_IMAGE {
    long focusID;
    long pushID;
    long overID;
    long setAudioLevel;
};

GD_IMAGE gD;

// Enable tooltip support
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")